VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Images from the Database"
   ClientHeight    =   5130
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   ScaleHeight     =   5130
   ScaleWidth      =   4905
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   3255
      Left            =   120
      ScaleHeight     =   3195
      ScaleWidth      =   4515
      TabIndex        =   4
      Top             =   240
      Width           =   4575
   End
   Begin VB.TextBox txtByteCount 
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   3960
      Width           =   2055
   End
   Begin VB.CommandButton cmdLoadImage 
      Caption         =   "Load Image"
      Height          =   615
      Left            =   3120
      TabIndex        =   1
      Top             =   4440
      Width           =   1575
   End
   Begin VB.CommandButton cmdAddImage 
      Caption         =   "Add Image"
      Height          =   615
      Left            =   840
      TabIndex        =   0
      Top             =   4440
      Width           =   1575
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Byte Count"
      Height          =   255
      Left            =   840
      TabIndex        =   2
      Top             =   4080
      Width           =   1695
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const conChunkSize = 8192       '2048 increment  multiples  depending the image sizes
Private Sub cmdAddImage_Click()
    Dim rsImage As Recordset
    Dim lOffset As Long
    Dim lSize As Long
    Dim sPath As String
    Dim nHandle As Integer
    Dim lSubChunks As Long
    Dim Chunk() As Byte
    Dim nFragmentOffset As Integer
    Dim i As Integer
    Dim lChunks As Long
    Dim lKey As Long
    Dim sSQL As String
    On Error GoTo cmdAddImage_Click_Error
    
    frmFileDialog.Show vbModal
    
    If gsFileName <> "" Then
        lKey = InputBox("Please enter a Number (1..n) as a key to the image")
        If lKey > 0 Then
        
            'check if unique Key
            sSQL = "select * from images"
            sSQL = sSQL & " where myKey=" & lKey
    
            Set rsImage = objDB.OpenRecordset(sSQL, dbOpenDynaset)
            If Not rsImage.EOF Then
                MsgBox "Key is already in use"
                GoTo Exit_cmdAddImage_Click
            End If
            
            Set Picture1.Picture = LoadPicture(gsFileName)
            
            Set rsImage = objDB.OpenRecordset("Images", dbOpenDynaset)
            
            nHandle = FreeFile
            Open gsFileName For Binary Access Read As nHandle
            
            lSize = LOF(nHandle)
            If nHandle = 0 Then
                Close nHandle
            End If
        
            lChunks = lSize \ conChunkSize
            nFragmentOffset = lSize Mod conChunkSize
            
            rsImage.AddNew
            rsImage("Description") = gsFileName
            rsImage("MyKey") = lKey
            
            ReDim Chunk(nFragmentOffset)
            Get nHandle, , Chunk()
            rsImage("A_Image").AppendChunk Chunk()
            ReDim Chunk(conChunkSize)
            lOffset = nFragmentOffset
            For i = 1 To lChunks
                Get nHandle, , Chunk()
                rsImage("A_Image").AppendChunk Chunk()
                lOffset = lOffset + conChunkSize
                txtByteCount = lOffset
                DoEvents
            Next
            
            rsImage.Update
        End If
    End If
    
Exit_cmdAddImage_Click:
        
   Exit Sub
    
cmdAddImage_Click_Error:
    
    #If gnDebug Then
        Stop
        Resume
    #End If

    HandleError "cmdAddImage_Click", Err.Description, Err.Number, gErrFormName
    Resume Exit_cmdAddImage_Click
    
End Sub

Private Sub cmdLoadImage_Click()
    Dim sSQL As String
    Dim lKey As Long
    Dim rsImage As Recordset
    Dim lSize As Long
    Dim varChunk() As Byte
    Dim lOffset As Long
    Dim sPath As String
    Dim nHandle As Integer
    Dim iChunks As Integer
    Dim nFragmentOffset As Integer
    Dim i As Integer
    Dim sFile As String
    On Error GoTo cmdLoadImage_Click_Error
    
    lKey = InputBox("Please input a Key")
    
    If lKey > 0 Then
        sSQL = "select * from images"
        sSQL = sSQL & " where myKey=" & lKey
    
        Set rsImage = objDB.OpenRecordset(sSQL, dbOpenDynaset)
    
        Screen.MousePointer = vbHourglass
        
        If Not rsImage.EOF Then
            nHandle = FreeFile
            sPath = App.Path
            sFile = sPath & "\output.bin"
            
            Open sFile For Binary Access Write As nHandle
           
           lSize = rsImage("a_image").FieldSize
    
           iChunks = lSize \ conChunkSize
           nFragmentOffset = lSize Mod conChunkSize
           
           ReDim Buffer(nFragmentOffset) As Byte
           varChunk() = rsImage("a_image").GetChunk(lOffset, nFragmentOffset)
           Put nHandle, , varChunk()
           lOffset = nFragmentOffset
           For i = 1 To iChunks
                ReDim varChunk(conChunkSize) As Byte
                varChunk() = rsImage("a_image").GetChunk(lOffset, conChunkSize)
                Put nHandle, , varChunk()
                lOffset = lOffset + conChunkSize
                txtByteCount = lOffset
                DoEvents
           Next
        
        End If
    
        Close nHandle
        
        Set Picture1.Picture = LoadPicture(sFile, , vbLPColor)
    End If
    
    
Exit_cmdLoadImage_Click:
        
    Screen.MousePointer = vbDefault
        
   Exit Sub
    
cmdLoadImage_Click_Error:
    
    #If gnDebug Then
        Stop
        Resume
    #End If

    HandleError "cmdLoadImage_Click", Err.Description, Err.Number, gErrFormName
    Resume Exit_cmdLoadImage_Click
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    
    If Not objDB Is Nothing Then
        objDB.Close
    End If
    Set objDB = Nothing
    
End Sub

